async function move(dir) {
    const headers = new Headers();
    headers.append("Content-Type", "application/json");
    await window.fetchAndRender({ method: 'POST', body: JSON.stringify({ dir }), headers })
}

function solve() {
    const x = document.getElementById('screen');
    const lines = x.innerText.split('\n');
    let player_pos, target_pos, bomb_pos;

    const distmap = [];
    for (let i = 0; i < lines.length; ++i) {
        distmap.push([]);
        for (let j = 0; j < lines[i].length; ++j) {
            distmap[i].push({ dist: Infinity, pred: null })
            if (lines[i][j] == '@') player_pos = [i, j];
            if (lines[i][j] == '+') target_pos = [i, j];
            if (lines[i][j] == '*') bomb_pos = [i, j];
        }
    }

    visit = (i, j) => {
        for (let [dir, i2, j2] of [['left', i, j + 1], ['right', i, j - 1], ['up', i + 1, j], ['down', i - 1, j]]) {
            if (i2 < 0 || i2 >= distmap.length
                || j2 < 0 || j2 >= distmap[0].length
                || (i2 == bomb_pos[0] && j2 == bomb_pos[1]))
                continue;

            let new_dist = distmap[i][j].dist + 1;
            if (new_dist < distmap[i2][j2].dist) {
                distmap[i2][j2].dist = new_dist;
                distmap[i2][j2].pred = dir;
                visit(i2, j2);
            }
        }
    }
    distmap[target_pos[0]][target_pos[1]].dist = 0;
    visit(...target_pos);

    const path = [];

    while (player_pos[0] != target_pos[0] || player_pos[1] != target_pos[1]) {
        const dir = distmap[player_pos[0]][player_pos[1]].pred;
        path.push(dir)
        switch (dir) {
            case 'up': player_pos[0] -= 1; break;
            case 'down': player_pos[0] += 1; break;
            case 'left': player_pos[1] -= 1; break;
            case 'right': player_pos[1] += 1; break;
        }
    }

    return path;
}

function run_path(path) {
    return new Promise((resolve, reject) => {
        const promises = [];
        const interval = setInterval(() => {
            promises.push(move(path.shift()));
            if (path.length == 0) {
                clearInterval(interval);
                resolve(Promise.all(promises));
            }
        }, 70);
    });
}

async function bot() {
    while (true) {
        const path = solve();
        await run_path(path);
    }
}