'use strict';
function findChar(grid, char) {
  var y = 0;
  for (let row of grid) {
    var x = 0;
    for (let c of row) {
      if (c === char) {
        return {
          x,
          y
        };
      }
      x++;
    }
    y++;
  }
  throw new Error("char " + char + "not found in grid");
}

function chooseDir(grid_) {
  const grid = grid_.split('\n');
  const playerPos = findChar(grid, '@');
  var closed = new Set([]);
  const hash = (x, y) => x + ' ' + y;
  var open = [{
    x: playerPos.x,
    y: playerPos.y,
    dir: null
  }];
  while (open.length > 0) {
    const {
      x,
      y,
      dir
    } = open.shift();
    if (closed.has(hash(x, y))) continue;
    closed.add(hash(x, y));
    const moves = [
      {nx: x - 1, ny: y, new_dir: 'left'},
      {nx: x + 1, ny: y, new_dir: 'right'},
      {nx: x, ny: y - 1, new_dir: 'up'},
      {nx: x, ny: y + 1, new_dir: 'down'},
    ];
    for (var {nx, ny, new_dir} of moves) {
      if (dir !== null) {
        new_dir = dir;
      }
      if (nx < 0 || nx >= 15 || ny < 0 || ny >= 5) continue;
      switch (grid[ny][nx]) {
        case '*':
          continue;
        case '+':
          return new_dir;
      }
      if (!closed.has(hash(nx, ny))) {
      open.push({
        x: nx,
        y: ny,
        dir: new_dir
      });
      }
    }
  }
  console.log(closed);
  throw new Error("unreachable");
}

async function scoreUntil(maxScore) {
  var dir = 'up';
  while (true) {
    const response = await fetch("/extra/game70", {
      method: "POST",
      body: JSON.stringify({
        dir
      }),
      headers,
    });
    const gameState = await response.json();
    renderGame(gameState);
    const {
      grid,
      s,
      score
    } = gameState;
    if (score >= maxScore) {
      return;
    }
    dir = chooseDir(grid);
  }
}
await scoreUntil(2024);
