! Copyright (C) 2025 Aleksander "olus2000" Sabak.
! See https://factorcode.org/license.txt for BSD license.

USING: accessors arrays assocs calendar concurrency.futures entry.pathing 
formatting hashtables http http.client io io.encodings.string io.encodings.utf8 
json json.http kernel math math.parser namespaces prettyprint sequences 
sequences.repeating threads ;
IN: entry

CONSTANT: session
"SESSION COOKIE HERE" 

: session-cookie ( -- cookie ) 
  session "session" <cookie> ;

: request ( method -- request )
  "https://codeguessing.gay/extra/game70" swap <client-request>
  session-cookie put-cookie ;  

: step-body ( direction -- post-data )
  "dir" associate <json-post-data> ;

: step-request ( direction -- request ) 
  "POST" request
  swap step-body >>post-data ;

SYMBOL: score

: print-score ( -- ) score get "score: %d\n" printf ; 

: request! ( request -- response )
  http-request nip utf8 decode json> ;

: respect ( response -- ) 
  [ "grid" of str>>grid ]
  [ "score" of score set ] bi ;

: init ( -- ) "GET" request request! respect ;

: travel ( path -- ) 
  [ [ step-request request! ] curry future 
    100 milliseconds sleep
  ] map
  [ ?future ] map 
  [ "s" of ] maximum-by respect ;
  
: print-state ( -- ) print-score print-grid ;

: perform-iteration ( -- ) path travel print-state ;

: entry ( -- )
  init print-state
  [ score get 2025 <  ]
  [ perform-iteration ] while ;

MAIN: entry

