! Copyright (C) 2025 Aleksander "olus2000" Sabak.
! See https://factorcode.org/license.txt for BSD license.

USING: io sequences kernel splitting namespaces ranges arrays math qw
math.vectors path-finding combinators ; 
IN: entry 

SYMBOL: grid

: str>>grid ( string -- )  
  "\n" split grid set ;

: print-grid ( -- ) 
  grid get "\n" join print ;

: tile ( position -- tile ) 
  reverse grid get [ swap nth ] reduce ; 

CONSTANT: deltas { { 1 0 } { 0 1 } { -1 0 } { 0 -1 } }
CONSTANT: extents { 15 5 } 

: inbounds? ( position -- ? ) 
  [ { 0 0 } swap v<= vall? ]
  [ extents v< vall? ] bi and ;
  
: neighbors ( position -- neighbors ) 
  deltas [ v+ ] with map
  [ inbounds? ] filter
  [ tile CHAR: * = ] reject ;

: where ( char -- position ) 
  grid get [ index ] with map
  [ ] find swap 2array ;

: delta>dir ( delta -- direction )
  deltas index qw{ right down left up } nth ; 

: path ( -- directions ) 
  CHAR: @ where 
  CHAR: + where 
  [ neighbors ] [ 2drop 1 ] [ 2drop 0 ] <astar> find-path 
  dup rest swap [ v- delta>dir ] 2map ;

